// ##### ENDFILE "EventWrap.h"


// ##### BEGINFILE "ReusableEventWrap.h"
/** @file
 * VirtualBox API class wrapper header for IReusableEvent.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/**
 * Copyright (C) 2010-2016 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#ifndef ReusableEventWrap_H_
#define ReusableEventWrap_H_

#include "VirtualBoxBase.h"
#include "Wrapper.h"

class ATL_NO_VTABLE ReusableEventWrap:
    public VirtualBoxBase,
    VBOX_SCRIPTABLE_IMPL(IReusableEvent)
{
    Q_OBJECT

public:
    VIRTUALBOXBASE_ADD_ERRORINFO_SUPPORT(ReusableEventWrap, IReusableEvent)
    DECLARE_NOT_AGGREGATABLE(ReusableEventWrap)
    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(ReusableEventWrap)
        COM_INTERFACE_ENTRY(ISupportErrorInfo)
        COM_INTERFACE_ENTRY(IReusableEvent)
        COM_INTERFACE_ENTRY(IEvent)
        COM_INTERFACE_ENTRY2(IDispatch, IReusableEvent)
        VBOX_TWEAK_INTERFACE_ENTRY(IReusableEvent)
    END_COM_MAP()

    DECLARE_EMPTY_CTOR_DTOR(ReusableEventWrap)

    // public IEvent properties
    STDMETHOD(COMGETTER(Type))(VBoxEventType_T *aType);
    STDMETHOD(COMGETTER(Source))(IEventSource **aSource);
    STDMETHOD(COMGETTER(Waitable))(BOOL *aWaitable);

    // public IReusableEvent properties
    STDMETHOD(COMGETTER(Generation))(ULONG *aGeneration);

    // public IEvent methods
    STDMETHOD(SetProcessed)();
    STDMETHOD(WaitProcessed)(LONG aTimeout,
                             BOOL *aResult);

    // public IReusableEvent methods
    STDMETHOD(Reuse)();

private:
    // wrapped IEvent properties
    virtual HRESULT getType(VBoxEventType_T *aType) = 0;
    virtual HRESULT getSource(ComPtr<IEventSource> &aSource) = 0;
    virtual HRESULT getWaitable(BOOL *aWaitable) = 0;

    // wrapped IReusableEvent properties
    virtual HRESULT getGeneration(ULONG *aGeneration) = 0;

    // wrapped IEvent methods
    virtual HRESULT setProcessed() = 0;
    virtual HRESULT waitProcessed(LONG aTimeout,
                                  BOOL *aResult) = 0;

    // wrapped IReusableEvent methods
    virtual HRESULT reuse() = 0;

private:
    DECLARE_CLS_COPY_CTOR_ASSIGN_NOOP(ReusableEventWrap); /* Shuts up MSC warning C4625. */

};

#endif // !ReusableEventWrap_H_

